unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    TabControl1: TTabControl;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    ffnen1: TMenuItem;
    Speichernunter1: TMenuItem;
    Beenden1: TMenuItem;
    Neu1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Makro1: TMenuItem;
    Makroerzeugen1: TMenuItem;
    Makroausfhern1: TMenuItem;
    procedure Beenden1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Neu1Click(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure EditorChange(Sender: TObject);
    procedure ffnen1Click(Sender: TObject);
    procedure Speichernunter1Click(Sender: TObject);
    procedure Makroerzeugen1Click(Sender: TObject);
    procedure Makroausfhern1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    {Bisher schrieb alles Delphi. Diese Zeilen mut Du selbst schreiben.
     Hier im Interface-Teil und ebenfalls unten im Implementation-Teil.
     Warum "private" ist hier unwichtig. Man knnte es auch global definieren.}
    editor: array of TRichedit; //Beliebig viele Dteien knnen eingelesen werden.
    pfad: array of String;      //Die Dateienpfade
    procedure NeuenEditor;      //Neben biher eingelesenen Dateien kann nooch
                                //eine weiter eingelesen werden-
    function eNr(Sender: TObject):integer; //Klick auf irgendeinen Editor liefert
                                           //hier seine Nummer
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const neu = 'Neu'; //Fr mehrmaligen Aufruf. Schreibfehler moniert Compiler.

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.eNr(Sender: TObject):integer;
  var k:integer;
begin
  if sender is TMenuItem then Begin
    if tabcontrol1.Tabs.Count = 0 then BEgin
      NeuenEditor;
      result := 0
    ENd else result := tabcontrol1.TabIndex;
    exit;
  End;
  for k := 0 to tabcontrol1.Tabs.Count -1 do
    if sender as TRichedit = editor[k] then Begin
      result := k;
      exit;
    End;
  NeuenEditor;
  eNr := 0;
end;

procedure TForm1.Beenden1Click(Sender: TObject);
begin
  close
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  form1.WindowState := wsmaximized;
end;

procedure TForm1.NeuenEditor;
  var e: TRichedit;
      nr: Integer;
begin
  e := Trichedit.Create(Form1);
  e.parent := tabcontrol1;
  e.Align := alclient;
  e.Font.Name := 'Courier New';
  e.Font.Size := 12;
  e.Font.Style := [fsbold];
  e.PlainText := true;
  e.MaxLength := 1000000; //wg. Bug in Delphi
  e.OnChange := editorChange;
  nr := tabcontrol1.Tabs.count+1;
  tabcontrol1.Tabs.Add(IntToStr(nr));
  tabcontrol1.TabIndex := nr-1;
  setlength(editor,nr);
  editor[nr-1] := e;
  setlength(pfad,nr);
  pfad[nr - 1] := Neu;
  form1.Caption := Neu;
  e.SetFocus;
end;

procedure TForm1.Neu1Click(Sender: TObject);

begin
  NeuenEditor;
end;

//Klick auf ein Register. Nun wird entsprechender Editor gezeigt.
procedure TForm1.TabControl1Change(Sender: TObject);
  var k, nr_minuseins: integer;
begin
  nr_minuseins :=  tabcontrol1.TabIndex;
  for k := 0 to tabcontrol1.Tabs.Count - 1 do
   if k = nr_minuseins then Begin
     editor[k].Show;
     editor[k].SetFocus;
     form1.Caption := pfad[k];
   End else editor[k].hide;
end;

//"*" kennzeichnet genderte Datei
procedure TForm1.EditorChange(Sender: TObject);
   var nr: Integer;
begin
 nr := eNR(Sender) + 1;
 tabcontrol1.Tabs[nr - 1] :=  IntToStr(nr)+'*';
end;

procedure TForm1.ffnen1Click(Sender: TObject);
  var nr:Integer;
begin
  if opendialog1.Execute then Begin
    if length(editor)=0 then Neueneditor;
    nr := eNr(Sender);
    if editor[nr].Text >'' then BEgin
       Neueneditor;
       nr := eNr(Sender);
     ENd;
     editor[Nr].Lines.LoadFromFile(opendialog1.filename);
     pfad[Nr] := opendialog1.filename;
     form1.Caption := pfad[Nr];
     tabcontrol1.Tabs[nr] := IntToStr(nr+1);  //ohne '*'
  End;
end;

procedure TForm1.Speichernunter1Click(Sender: TObject);
  var nr:Integer;
begin
  nr := eNr(Sender);
  with savedialog1 do Begin
    InitialDir := ExtractFileDir(pfad[Nr]);
    filename := ExtractFileName(pfad[nr]);
    if Execute then BEgin
      editor[Nr].lines.SaveToFile(filename);
      pfad[Nr] := filename;
      form1.Caption := filename;
      tabcontrol1.Tabs[nr] := IntToStr(nr+1); //ohne *
    ENd;
  End;
end;

function inidatei: string;
begin
 iniDatei := Lowercase(copy(paramstr(0),1,length(paramstr(0))-3) + 'ini'); //ini statt exe
end;

procedure TForm1.Makroerzeugen1Click(Sender: TObject);
  var k,nr: integer;
begin
   showmessage('Alle momentan eingelesenen Datein knnen Sie beim nchsten Start'#13+
               'mit Men "Dateien einlesen" zusammen einlesen.'#13+
               'Sie knnen das Makro ndern und erneut abspeichern.');
   if length(editor) = 0 then  Begin
       showmessage('Abbruch!'#13'Zuerst Dateien schreiben oder einlesen!');
       exit;
     End;
   NeuenEditor;
   nr := length(editor);
   for k := 0 to nr - 2 do if pfad[k] = Neu then
     showmessage('Datei "'+neu+'" kann nicht eingelesen werden')
       else editor[nr-1].lines.Add(pfad[k]);
   editor[nr-1].Lines.SaveToFile(iniDatei);
   pfad[nr - 1] := iniDatei;
   form1.Caption := inidatei;
   tabcontrol1.Tabs[nr-1] := IntToStr(nr); //ohne *
end;

procedure TForm1.Makroausfhern1Click(Sender: TObject);
  var pu: Tstringlist;
      k, nr:integer;
begin
  //noch pu = nil
  pu := Tstringlist.Create; //falls erfolgreich pu <> nil
  try pu.LoadFromFile(inidatei);
  Except showmessage('Noch kein Makro erzeugt'); exit; End;
  try
    for k := 0 to pu.Count - 1 do Begin
      neuenEditor;
      nr := length(editor) - 1;
      editor[nr].Lines.LoadFromFile(pu[k]);
      tabcontrol1.Tabs[nr] := IntToStr(nr+1); //ohne *
      pfad[nr] := pu[k];
    End;
  finally pu.free End; //free = destroy, falls pu <> nil
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  var k:integer;
begin
  CanClose := true;
  for k := 0 to length(editor) - 1 do
    if pos('*',tabcontrol1.Tabs[k]) > 0 then
      if MessageDlg('Noch nicht alle Dateien sind gesichert. Trotzdem beenden?',
        mtConfirmation, [mbYes, mbNo], 0) = mrNo then CanClose := false;
end;

end.
